"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

var _react = _interopRequireDefault(require("react"));

var stories = _interopRequireWildcard(require("./ClearButton.stories"));

var _helpers = require("../../tests/helpers");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _composeStories = (0, _helpers.composeStories)(stories),
    Default = _composeStories.Default,
    Large = _composeStories.Large;

describe('<ClearButton>', function () {
  (0, _helpers.generateSnapshots)(stories);
  it('renders a default clear button', function () {
    (0, _helpers.render)( /*#__PURE__*/_react["default"].createElement(Default, null));
    expect(_helpers.screen.getByRole('button').className).toBe('close btn-close rbt-close');
  });
  it('renders a large clear button', function () {
    (0, _helpers.render)( /*#__PURE__*/_react["default"].createElement(Large, null));
    expect(_helpers.screen.getByRole('button').className).toContain('rbt-close-lg');
  });
  it('registers a click', function () {
    var onClick = jest.fn();
    (0, _helpers.render)( /*#__PURE__*/_react["default"].createElement(Default, {
      onClick: onClick
    }));

    var button = _helpers.screen.getByRole('button');

    _helpers.userEvent.click(button);

    expect(onClick).toHaveBeenCalledTimes(1);
  });
  it('prevents the default backspace behavior', function () {
    var onKeyDown = jest.fn();
    var isDefault;
    (0, _helpers.render)( /*#__PURE__*/_react["default"].createElement(Default, {
      onKeyDown: onKeyDown
    }));

    var button = _helpers.screen.getByRole('button');

    isDefault = _helpers.fireEvent.keyDown(button, {
      key: 'Backspace'
    });
    expect(onKeyDown).toHaveBeenCalledTimes(1);
    expect(isDefault).toBe(false);
    isDefault = _helpers.fireEvent.keyDown(button, {
      key: 'Enter'
    });
    expect(onKeyDown).toHaveBeenCalledTimes(2);
    expect(isDefault).toBe(true);
  });
});