"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _getDisplayName = _interopRequireDefault(require("./getDisplayName"));

var displayName = 'AnotherName';

var anonymize = function anonymize(Component) {
  return function () {
    return /*#__PURE__*/_react["default"].createElement(Component, null);
  };
};

var NamedComponent = function NamedComponent() {
  return /*#__PURE__*/_react["default"].createElement("div", null);
};

describe('getDisplayName', function () {
  it('returns the displayName of the component', function () {
    expect((0, _getDisplayName["default"])(NamedComponent)).toBe('NamedComponent');
    NamedComponent.displayName = displayName;
    expect((0, _getDisplayName["default"])(NamedComponent)).toBe(displayName); // HOCs will obscure the name and displayName.

    expect((0, _getDisplayName["default"])(anonymize(NamedComponent))).toBe('Component');
  });
});