"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _getInputProps = _interopRequireDefault(require("./getInputProps"));

var _helpers = require("../tests/helpers");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var baseProps = {
  activeIndex: -1,
  id: 'id',
  isFocused: false,
  isMenuShown: false,
  multiple: false
};

var baseMultiProps = _objectSpread(_objectSpread({}, baseProps), {}, {
  multiple: true,
  onRemove: _helpers.noop
});

var baseReceivedProps = {
  'aria-activedescendant': undefined,
  'aria-autocomplete': 'both',
  'aria-expanded': false,
  'aria-haspopup': 'listbox',
  'aria-owns': undefined,
  autoComplete: 'off',
  className: '',
  onClick: undefined,
  onFocus: undefined,
  placeholder: undefined,
  role: 'combobox',
  type: 'text'
};

var baseReceivedMultiProps = _objectSpread(_objectSpread({}, baseReceivedProps), {}, {
  'aria-autocomplete': 'list',
  'aria-expanded': undefined,
  inputClassName: undefined,
  onRemove: _helpers.noop,
  role: undefined
});

describe('getInputProps', function () {
  it('receives single-select input props', function () {
    var inputProps = (0, _getInputProps["default"])(baseProps)();
    expect(inputProps).toEqual(baseReceivedProps);
    inputProps = (0, _getInputProps["default"])(_objectSpread(_objectSpread({}, baseProps), {}, {
      activeIndex: 0,
      isFocused: true,
      isMenuShown: true
    }))({
      className: 'foo'
    });
    expect(inputProps).toEqual(_objectSpread(_objectSpread({}, baseReceivedProps), {}, {
      'aria-activedescendant': 'id-item-0',
      'aria-expanded': true,
      'aria-owns': 'id',
      className: 'foo focus'
    }));
  });
  it('receives multi-select input props', function () {
    var inputProps = (0, _getInputProps["default"])(baseMultiProps)();
    expect(inputProps).toEqual(baseReceivedMultiProps);
    inputProps = (0, _getInputProps["default"])(_objectSpread(_objectSpread({}, baseMultiProps), {}, {
      isFocused: true
    }))({
      className: 'foo'
    });
    expect(inputProps).toEqual(_objectSpread(_objectSpread({}, baseReceivedMultiProps), {}, {
      className: 'focus',
      inputClassName: 'foo'
    }));
  });
});