"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _getInputText = _interopRequireDefault(require("./getInputText"));

var _data = _interopRequireDefault(require("../tests/data"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var labelKey = 'name';
var baseArgs = {
  activeItem: null,
  labelKey: labelKey,
  multiple: false,
  selected: [],
  text: ''
};
describe('getInputText', function () {
  it('returns an empty string when no text is entered', function () {
    var inputText = (0, _getInputText["default"])(baseArgs);
    expect(inputText).toBe('');
  });
  it('returns the input text in multiple mode', function () {
    var text = 'Cali';
    var inputText = (0, _getInputText["default"])(_objectSpread(_objectSpread({}, baseArgs), {}, {
      multiple: true,
      text: text
    }));
    expect(inputText).toBe(text);
  });
  it('returns the active option label in single-select mode', function () {
    var name = 'California';
    var inputText = (0, _getInputText["default"])(_objectSpread(_objectSpread({}, baseArgs), {}, {
      activeItem: {
        name: name
      }
    }));
    expect(inputText).toBe(name);
  });
  it('returns the active option label in multi-select mode', function () {
    var name = 'California';
    var inputText = (0, _getInputText["default"])(_objectSpread(_objectSpread({}, baseArgs), {}, {
      activeItem: {
        name: name
      },
      multiple: true
    }));
    expect(inputText).toBe(name);
  });
  it('returns the selected item label in single-select mode', function () {
    var selected = _data["default"].slice(0, 1);

    var inputText = (0, _getInputText["default"])(_objectSpread(_objectSpread({}, baseArgs), {}, {
      selected: selected
    }));
    expect(inputText).toBe(selected[0][labelKey]);
  });
  it('does not return the selected item label in multi-select mode', function () {
    var inputText = (0, _getInputText["default"])(_objectSpread(_objectSpread({}, baseArgs), {}, {
      multiple: true,
      selected: _data["default"].slice(0, 1)
    }));
    expect(inputText).toBe('');
  });
});