"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _getTruncatedOptions = _interopRequireDefault(require("./getTruncatedOptions"));

var _data = _interopRequireDefault(require("../tests/data"));

describe('getTruncatedOptions', function () {
  it('truncates the results', function () {
    var maxResults = 10;
    var truncatedResults = (0, _getTruncatedOptions["default"])(_data["default"], maxResults);
    expect(truncatedResults.length).toBe(maxResults);
  });
  it('does not truncate the results if the threshold is not met', function () {
    var maxResults = 100;
    var truncatedResults = (0, _getTruncatedOptions["default"])(_data["default"], maxResults);
    expect(truncatedResults.length).toBe(_data["default"].length);
  });
  it('does not truncate the results if `maxResults=0`', function () {
    var maxResults = 0;
    var truncatedResults = (0, _getTruncatedOptions["default"])(_data["default"], maxResults);
    expect(truncatedResults.length).toBe(_data["default"].length);
  });
});