"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

var _getUpdatedActiveIndex = _interopRequireWildcard(require("./getUpdatedActiveIndex"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var options = [{
  name: 'foo'
}, {
  disabled: true,
  name: 'bar'
}, {
  disabled: true,
  name: 'boo'
}, {
  name: 'baz'
}];
var stringOptions = ['foo', 'bar', 'baz'];
test('getUpdatedActiveIndex', function () {
  expect((0, _getUpdatedActiveIndex["default"])(-1, 'ArrowDown', options)).toBe(0);
  expect((0, _getUpdatedActiveIndex["default"])(0, 'ArrowDown', options)).toBe(3);
  expect((0, _getUpdatedActiveIndex["default"])(3, 'ArrowDown', options)).toBe(-1);
  expect((0, _getUpdatedActiveIndex["default"])(-1, 'ArrowUp', options)).toBe(3);
  expect((0, _getUpdatedActiveIndex["default"])(3, 'ArrowUp', options)).toBe(0);
  expect((0, _getUpdatedActiveIndex["default"])(0, 'ArrowUp', options)).toBe(-1);
});
test('skipDisabledOptions', function () {
  expect((0, _getUpdatedActiveIndex.skipDisabledOptions)(0, 'ArrowDown', options)).toBe(0);
  expect((0, _getUpdatedActiveIndex.skipDisabledOptions)(0, 'ArrowUp', options)).toBe(0);
  expect((0, _getUpdatedActiveIndex.skipDisabledOptions)(1, 'ArrowDown', options)).toBe(3);
  expect((0, _getUpdatedActiveIndex.skipDisabledOptions)(1, 'ArrowUp', options)).toBe(0);
  expect((0, _getUpdatedActiveIndex.skipDisabledOptions)(1, 'ArrowDown', stringOptions)).toBe(1);
  expect((0, _getUpdatedActiveIndex.skipDisabledOptions)(1, 'ArrowUp', stringOptions)).toBe(1);
});
test('isDisabledOption', function () {
  expect((0, _getUpdatedActiveIndex.isDisabledOption)(0, options)).toBe(false);
  expect((0, _getUpdatedActiveIndex.isDisabledOption)(1, options)).toBe(true);
  expect((0, _getUpdatedActiveIndex.isDisabledOption)(6, options)).toBe(false);
  expect((0, _getUpdatedActiveIndex.isDisabledOption)(0, stringOptions)).toBe(false);
});