"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _isSelectable = _interopRequireDefault(require("./isSelectable"));

describe('isSelectable', function () {
  it('identifies selectable elements', function () {
    var input = document.createElement('input');
    input.setAttribute('type', 'text');
    expect((0, _isSelectable["default"])(input)).toBe(true);
    input.setAttribute('type', 'search');
    expect((0, _isSelectable["default"])(input)).toBe(true);
    input.setAttribute('type', 'password');
    expect((0, _isSelectable["default"])(input)).toBe(true);
    input.setAttribute('type', 'tel');
    expect((0, _isSelectable["default"])(input)).toBe(true);
    input.setAttribute('type', 'url');
    expect((0, _isSelectable["default"])(input)).toBe(true);
    var textarea = document.createElement('textarea'); // Must explicitly set selection range for `selectionStart` to have a value.

    textarea.setSelectionRange(0, 0);
    expect((0, _isSelectable["default"])(textarea)).toBe(true);
  });
  it('identifies non-selectable inputs', function () {
    var input = document.createElement('input');
    input.setAttribute('type', 'email');
    expect((0, _isSelectable["default"])(input)).toBe(false);
    input.setAttribute('type', 'number');
    expect((0, _isSelectable["default"])(input)).toBe(false);
    var div = document.createElement('div');
    expect((0, _isSelectable["default"])(div)).toBe(false);
  });
});