"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isShown = _interopRequireDefault(require("./isShown"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var baseProps = {
  minLength: 0,
  showMenu: false,
  text: ''
};
describe('isShown', function () {
  it('shows the menu', function () {
    expect((0, _isShown["default"])(_objectSpread(_objectSpread({}, baseProps), {}, {
      showMenu: true
    }))).toBe(true);
  });
  it('shows the menu when `open` is true', function () {
    expect((0, _isShown["default"])(_objectSpread(_objectSpread({}, baseProps), {}, {
      open: true
    }))).toBe(true);
  });
  it('hides the menu when `open` is false', function () {
    var props = _objectSpread(_objectSpread({}, baseProps), {}, {
      open: false,
      showMenu: true
    });

    expect((0, _isShown["default"])(props)).toBe(false);
  });
  it('hides the menu when `showMenu` is false', function () {
    expect((0, _isShown["default"])(baseProps)).toBe(false);
  });
  it('hides the menu when the input value is less than `minLength`', function () {
    var props = _objectSpread(_objectSpread({}, baseProps), {}, {
      minLength: 1,
      showMenu: true
    });

    expect((0, _isShown["default"])(props)).toBe(false);
  });
});