"use strict";

var _nodash = require("./nodash");

var arr = [];
var fn = _nodash.noop;
var obj = {};
var str = 'foo';
describe('nodash', function () {
  test('isFunction', function () {
    expect((0, _nodash.isFunction)(fn)).toBe(true);
    [arr, obj, str, null, undefined, NaN].forEach(function (arg) {
      expect((0, _nodash.isFunction)(arg)).toBe(false);
    });
  });
  test('isString', function () {
    expect((0, _nodash.isString)(str)).toBe(true);
    [arr, obj, fn, null, undefined, NaN].forEach(function (arg) {
      expect((0, _nodash.isString)(arg)).toBe(false);
    });
  });
  test('pick', function () {
    var object = {
      bar: 'one',
      foo: 'two'
    };
    expect((0, _nodash.pick)(object, ['bar'])).toEqual({
      bar: 'one'
    });
    expect((0, _nodash.pick)(object, ['baz'])).toEqual({});
  });
  test('uniqueId', function () {
    expect((0, _nodash.uniqueId)()).toBe('1');
    expect((0, _nodash.uniqueId)('foo-')).toBe('foo-2');
  });
});