"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _propsWithBsClassName8 = _interopRequireDefault(require("./propsWithBsClassName"));

describe('propsWithBsClassName', function () {
  it('returns a basic classname', function () {
    var _propsWithBsClassName = (0, _propsWithBsClassName8["default"])({}),
        className = _propsWithBsClassName.className;

    expect(className).toBe('form-control rbt-input');
  });
  it('includes a classname for a large input', function () {
    var _propsWithBsClassName2 = (0, _propsWithBsClassName8["default"])({
      size: 'lg'
    }),
        className = _propsWithBsClassName2.className;

    expect(className).toContain('form-control-lg');
  });
  it('includes a classname for a small input', function () {
    var _propsWithBsClassName3 = (0, _propsWithBsClassName8["default"])({
      size: 'sm'
    }),
        className = _propsWithBsClassName3.className;

    expect(className).toContain('form-control-sm');
  });
  it('includes a classname for an invalid input', function () {
    var _propsWithBsClassName4 = (0, _propsWithBsClassName8["default"])({
      isInvalid: true
    }),
        className = _propsWithBsClassName4.className;

    expect(className).toContain('is-invalid');
  });
  it('includes a classname for a valid input', function () {
    var _propsWithBsClassName5 = (0, _propsWithBsClassName8["default"])({
      isValid: true
    }),
        className = _propsWithBsClassName5.className;

    expect(className).toContain('is-valid');
  });
  it('includes an arbitrary classname', function () {
    var _propsWithBsClassName6 = (0, _propsWithBsClassName8["default"])({
      className: 'foo'
    }),
        className = _propsWithBsClassName6.className;

    expect(className).toContain('foo');
  });
  it('returns pass-through props', function () {
    var _propsWithBsClassName7 = (0, _propsWithBsClassName8["default"])({
      foo: 'bar'
    }),
        foo = _propsWithBsClassName7.foo;

    expect(foo).toBe('bar');
  });
});