"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _validateSelectedPropChange = _interopRequireDefault(require("./validateSelectedPropChange"));

/* eslint-disable no-console */
describe('validateSelectedPropChange', function () {
  var str;
  beforeEach(function () {
    console.error = jest.fn(function (msg) {
      return str = msg;
    });
  });
  it('does not trigger a warning', function () {
    (0, _validateSelectedPropChange["default"])([], ['foo']);
    expect(console.error).toHaveBeenCalledTimes(0);
  });
  it('warns about uncontrolled to controlled change', function () {
    (0, _validateSelectedPropChange["default"])(undefined, []);
    var msg = 'You are changing an uncontrolled typeahead to be controlled. Input ' + 'elements should not switch from uncontrolled to controlled (or vice ' + 'versa). Decide between using a controlled or uncontrolled element for ' + 'the lifetime of the component.';
    expect(console.error).toHaveBeenCalledTimes(1);
    expect(str).toMatch(msg);
  });
  it('warns about controlled to uncontrolled change', function () {
    (0, _validateSelectedPropChange["default"])([], undefined);
    var msg = 'You are changing a controlled typeahead to be uncontrolled. Input ' + 'elements should not switch from controlled to uncontrolled (or vice ' + 'versa). Decide between using a controlled or uncontrolled element for ' + 'the lifetime of the component.';
    expect(console.error).toHaveBeenCalledTimes(1);
    expect(str).toMatch(msg);
  });
});