import React from 'react';
import * as stories from './Loader.stories';
import { composeStories, generateSnapshots, render, screen } from '../../tests/helpers';

var _composeStories = composeStories(stories),
    Default = _composeStories.Default;

describe('<Loader>', function () {
  generateSnapshots(stories);
  it('renders a loading indicator', function () {
    render( /*#__PURE__*/React.createElement(Default, null));
    expect(screen.getByRole('status')).toHaveClass('rbt-loader spinner-border spinner-border-sm');
    expect(screen.getByText('Loading...')).toBeTruthy();
  });
  it('renders a custom label for accessibility', function () {
    render( /*#__PURE__*/React.createElement(Default, {
      label: "Waiting..."
    }));
    expect(screen.getByText('Waiting...')).toBeTruthy();
  });
});