import React from 'react';
import getDisplayName from './getDisplayName';
var displayName = 'AnotherName';

var anonymize = function anonymize(Component) {
  return function () {
    return /*#__PURE__*/React.createElement(Component, null);
  };
};

var NamedComponent = function NamedComponent() {
  return /*#__PURE__*/React.createElement("div", null);
};

describe('getDisplayName', function () {
  it('returns the displayName of the component', function () {
    expect(getDisplayName(NamedComponent)).toBe('NamedComponent');
    NamedComponent.displayName = displayName;
    expect(getDisplayName(NamedComponent)).toBe(displayName); // HOCs will obscure the name and displayName.

    expect(getDisplayName(anonymize(NamedComponent))).toBe('Component');
  });
});