import getIsOnlyResult from './getIsOnlyResult';
describe('getIsOnlyResult', function () {
  var props;
  beforeEach(function () {
    props = {
      allowNew: false,
      highlightOnlyResult: true,
      results: ['The only result!']
    };
  });
  it('returns true when there is only one result', function () {
    expect(getIsOnlyResult(props)).toBe(true);
  });
  it('returns false when `highlightOnlyResult` is disabled', function () {
    props.highlightOnlyResult = false;
    expect(getIsOnlyResult(props)).toBe(false);
  });
  it('returns false when custom options are allowed', function () {
    props.allowNew = true;
    expect(getIsOnlyResult(props)).toBe(false);
  });
  it('returns false when there are more or less than one result', function () {
    props.results = ['One', 'Two'];
    expect(getIsOnlyResult(props)).toBe(false);
    props.results = [];
    expect(getIsOnlyResult(props)).toBe(false);
  });
  it('returns false when the only result is disabled', function () {
    props.results = [{
      disabled: true
    }];
    expect(getIsOnlyResult(props)).toBe(false);
  });
});