import getTruncatedOptions from './getTruncatedOptions';
import options from '../tests/data';
describe('getTruncatedOptions', function () {
  it('truncates the results', function () {
    var maxResults = 10;
    var truncatedResults = getTruncatedOptions(options, maxResults);
    expect(truncatedResults.length).toBe(maxResults);
  });
  it('does not truncate the results if the threshold is not met', function () {
    var maxResults = 100;
    var truncatedResults = getTruncatedOptions(options, maxResults);
    expect(truncatedResults.length).toBe(options.length);
  });
  it('does not truncate the results if `maxResults=0`', function () {
    var maxResults = 0;
    var truncatedResults = getTruncatedOptions(options, maxResults);
    expect(truncatedResults.length).toBe(options.length);
  });
});