/// <reference types="react" />
import { TypeaheadManagerProps } from '../types';
declare const getInputProps: ({ activeIndex, id, isFocused, isMenuShown, multiple, onClick, onFocus, placeholder, ...rest }: TypeaheadManagerProps) => (inputProps?: {}) => {
    'aria-activedescendant': string | undefined;
    'aria-autocomplete': string;
    'aria-expanded': boolean;
    'aria-haspopup': string;
    'aria-owns': string | undefined;
    className: string;
    onClick: import("react").MouseEventHandler<HTMLInputElement>;
    onFocus: (event: import("react").SyntheticEvent<HTMLInputElement, Event>) => void;
    role: string;
    hideMenu: () => void;
    inputNode: import("../types").RefElement<HTMLInputElement>;
    inputRef: (instance: HTMLInputElement | null) => void;
    onActiveItemChange: import("../types").OptionHandler;
    onAdd: import("../types").OptionHandler;
    onChange: import("react").ChangeEventHandler<HTMLInputElement>;
    onClear: () => void;
    onHide: () => void;
    onInitialItemChange: (option?: import("../types").Option | undefined) => void;
    onMenuItemClick: (option: import("../types").Option, event: import("../types").SelectEvent<HTMLElement>) => void;
    onRemove: import("../types").OptionHandler;
    results: import("../types").Option[];
    setItem: (item: import("../types").Option, position: number) => void;
    toggleMenu: () => void;
    allowNew: import("../types").AllowNew;
    autoFocus: boolean;
    caseSensitive: boolean;
    children: import("../types").TypeaheadChildren;
    defaultInputValue: string;
    defaultOpen: boolean;
    defaultSelected: import("../types").Option[];
    emptyLabel?: import("react").ReactNode;
    filterBy: import("../types").FilterByCallback | string[];
    highlightOnlyResult: boolean;
    ignoreDiacritics: boolean;
    inputProps?: import("../types").InputProps | undefined;
    labelKey: import("../types").LabelKey;
    maxResults: number;
    minLength: number;
    onBlur: import("react").FocusEventHandler<HTMLInputElement>;
    onInputChange: (text: string, event: import("react").ChangeEvent<HTMLInputElement>) => void;
    onKeyDown: import("react").KeyboardEventHandler<HTMLInputElement>;
    onMenuToggle: (isOpen: boolean) => void;
    onPaginate: (event: import("../types").SelectEvent<HTMLElement>, shownResults: number) => void;
    open?: boolean | undefined;
    options: import("../types").Option[];
    paginate: boolean;
    selected: import("../types").Option[];
    selectHint?: import("../types").SelectHint | undefined;
    activeItem?: import("../types").Option | undefined;
    initialItem?: import("../types").Option | undefined;
    showMenu: boolean;
    shownResults: number;
    text: string;
    autoComplete: string;
    placeholder: string | undefined;
    type: string;
} | {
    'aria-autocomplete': string;
    'aria-expanded': undefined;
    inputClassName: unknown;
    role: undefined;
    'aria-activedescendant': string | undefined;
    'aria-haspopup': string;
    'aria-owns': string | undefined;
    className: string;
    onClick: import("react").MouseEventHandler<HTMLInputElement>;
    onFocus: (event: import("react").SyntheticEvent<HTMLInputElement, Event>) => void;
    hideMenu: () => void;
    inputNode: import("../types").RefElement<HTMLInputElement>;
    inputRef: (instance: HTMLInputElement | null) => void;
    onActiveItemChange: import("../types").OptionHandler;
    onAdd: import("../types").OptionHandler;
    onChange: import("react").ChangeEventHandler<HTMLInputElement>;
    onClear: () => void;
    onHide: () => void;
    onInitialItemChange: (option?: import("../types").Option | undefined) => void;
    onMenuItemClick: (option: import("../types").Option, event: import("../types").SelectEvent<HTMLElement>) => void;
    onRemove: import("../types").OptionHandler;
    results: import("../types").Option[];
    setItem: (item: import("../types").Option, position: number) => void;
    toggleMenu: () => void;
    allowNew: import("../types").AllowNew;
    autoFocus: boolean;
    caseSensitive: boolean;
    children: import("../types").TypeaheadChildren;
    defaultInputValue: string;
    defaultOpen: boolean;
    defaultSelected: import("../types").Option[];
    emptyLabel?: import("react").ReactNode;
    filterBy: import("../types").FilterByCallback | string[];
    highlightOnlyResult: boolean;
    ignoreDiacritics: boolean;
    inputProps?: import("../types").InputProps | undefined;
    labelKey: import("../types").LabelKey;
    maxResults: number;
    minLength: number;
    onBlur: import("react").FocusEventHandler<HTMLInputElement>;
    onInputChange: (text: string, event: import("react").ChangeEvent<HTMLInputElement>) => void;
    onKeyDown: import("react").KeyboardEventHandler<HTMLInputElement>;
    onMenuToggle: (isOpen: boolean) => void;
    onPaginate: (event: import("../types").SelectEvent<HTMLElement>, shownResults: number) => void;
    open?: boolean | undefined;
    options: import("../types").Option[];
    paginate: boolean;
    selected: import("../types").Option[];
    selectHint?: import("../types").SelectHint | undefined;
    activeItem?: import("../types").Option | undefined;
    initialItem?: import("../types").Option | undefined;
    showMenu: boolean;
    shownResults: number;
    text: string;
    autoComplete: string;
    placeholder: string | undefined;
    type: string;
};
export default getInputProps;
